/*
Dozen Days of Words episode 9: Crystal Skull
Copyright (c) 2009 Blazing Games Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.dozendays.words.skull
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import flash.media.Sound;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.utils.getTimer;
	import flash.ui.Keyboard;

	import com.blazinggames.dozendays.*;
	import com.blazinggames.dozendays.words.*;

	public class SkullGame
	extends Sprite
	{
// ***** CONSTANTS **********************************************************

		public static const BACKGROUND_COLOR:uint = 0x000050;
		public static const TILE_COLOR:uint = 0xC0C050;
		public static const BORDER_COLOR:uint = 0x000030;
		public static const LETTER_COLOR:uint = 0x200020;
		public static const TILE_COLOR_DIM:uint = 0xC000C0;
		public static const LETTER_COLOR_DIM:uint = 0x500050;
		public static const HIGHLIGHT_COLOR:uint = 0xFF0050;
		public static const WORD_COLOR:uint = 0x00C000;

		public static const PREDCTIONS:Array = new Array(
			"Yes", "Certainly", "I\'m\npositive", "For\nsure", "Count\non\nit",
			"Very\nlikely", "It\ncould\nhappen", "There\nis\nhope", "Above\naverage\nchance", "Probably",
			"Not\nclear", "Maybe", "Rephrase\nthe\nquestion", "I\ncan\'t\nforesee", "Ask\nagain\nlater",
			"Unlikely", "Very\nlittle\nhope", "Probably\nnot", "Odds\nare\nlow", "Not\nlikely\nto\nhappen",
			"No", "Don\'t\ncount\non\nit", "Never", "Certainly\nnot", "Negative");

// ***** VARIABLES **********************************************************

		[Embed(source="Skull.swf")]
		private var SkullMovie:Class;
		public var _movie:MovieClip;

		[Embed(source="prediction.mp3")]
		private var WinSound:Class;
		private var _sound:Sound;
		
		protected var _skull:CrystalSkull;
		protected var _doneButton:TextButton;
		protected var _prediction:SpookyText;
		protected var _angle:int;
//		protected var _backdrop:TextField;
		protected var _madePrediction:Boolean;
		
// ***** CONSTRUCTOR ********************************************************

		public function SkullGame(skull:CrystalSkull)
		{
			_skull = skull;
/*
			_backdrop = new TextField();
			_backdrop.multiline = true;
			_backdrop.width = 640;
			_backdrop.height = 480;
			_backdrop.textColor = 0xC000C0;
			_backdrop.background = true;
			_backdrop.backgroundColor = BACKGROUND_COLOR;
			addChild(_backdrop);
*/
			_movie = MovieClip(new SkullMovie());
			addChild(_movie);
			
			_sound = Sound(new WinSound());
/*			
			_prediction = new TextField();
			_prediction.multiline = true;
			_prediction.wordWrap = true;
			_prediction.width = 640;
			_prediction.height = 480;
			_prediction.textColor = 0xC000C0;
*/
			_prediction = new SpookyText(600,400,"Spooky");
			_prediction.x = 20;
			_prediction.y = 20;
			_prediction._format.align = "right";
			addChild(_prediction);
			
			_doneButton = new TextButton("Exit", 240, 50);
			_doneButton.x = 400;
			_doneButton.y = 430;
			addChild(_doneButton);
			_doneButton.addEventListener(MouseEvent.MOUSE_UP, handleExit);

		}

// ***** Functions - Puzzle Handling ****************************************

		public function startGame(playmode:int = 3):void
		{
			_madePrediction = false;
			_prediction.setText("Ask\nyour\nquestion\nnow\nmortal\n!");
			_doneButton.setLabel("Predict");
		}


// ***** Functions - Event Handling *****

		private function handleExit(evt:Event):void
		{
			if (_madePrediction) {
				_skull.changeMode(CrystalSkull.MODE_TITLE);
			} else {
				_madePrediction = true;
				_doneButton.setLabel("Exit");
				_prediction.setText( PREDCTIONS[Math.floor(Math.random() * PREDCTIONS.length)] );
				_sound.play();
			}
		}

		public function updateTime():void
		{
			_angle++;
			if (_angle > 359)
				_angle -= 360;
			var mx:Number = 60 * Math.sin(_angle * Math.PI/180) + 75;
			var my:Number = 60 * Math.cos(_angle * Math.PI/180) + 75;
			_movie.x = mx;
			_movie.y = my;
		}
		
// ***** Functions - game handling *******************************************

		public function handleKeypress(keycode:uint):void
		{
/*
			if ( (keycode >= 65) && (keycode <= 90) ) {
				_tiles[_cursorIndex].setLetter(String.fromCharCode(keycode));
				if (_tiles[_cursorIndex].getHorizontalClue() != null)
					keycode = Keyboard.RIGHT;
				else
					keycode = Keyboard.DOWN;
			}
			var cursorX:int = _cursorIndex % _boardWidth;
			var cursorY:int = _cursorIndex / _boardWidth;
			switch (keycode) {
				case Keyboard.UP:
					--cursorY;
					if (cursorY < 0)
						cursorY = _boardHeight - 1;
					break;
				case Keyboard.LEFT:
					--cursorX;
					if (cursorX < 0)
						cursorX = _boardWidth - 1;
					break;
				case Keyboard.RIGHT:
					++cursorX;
					if (cursorX >= _boardWidth)
						cursorX = 0;
					break;
				case Keyboard.DOWN:
					++cursorY;
					if (cursorY >= _boardHeight)
						cursorY = 0;
					break;
			}
			setCursorLocation(cursorY * _boardWidth + cursorX);
*/
		}
	}
}
